;;;; remote-mailbox-test.scm

; should run multiple senders
;
; doesn't have good shutdown of socket
;
;X should have a better way to terminate the tcp-server loop
; - close the port

(import scheme
  (chicken base)
  (chicken process-context)
  (chicken process)
  (chicken format)
  (srfi 1)
  (srfi 18)
  miscmacros
  exn-condition
  mailbox
  remote-mailbox-client remote-mailbox-server
  remote-mailbox-adapter)

(define-constant NUM-MSG 5)
(define-constant RCV-NAM "Wong Foo")
(define MB-NAM 'wong-foo)

(define (server)
  (let ((rmbs (make-remote-mailbox-server #:name MB-NAM #:debug RCV-NAM)))
    (values rmbs (remote-mailbox-server-start! rmbs)) ) )

(define (sender)
  (print "* Sending " NUM-MSG " messages")
  (let ((rmb (make-remote-mailbox MB-NAM)))
    (dotimes (n NUM-MSG)
      ;a message can be any object
      (let ((msg (vector 'message `(recipient ,RCV-NAM) `(id ,n))))
        (format #t "Sending |~S| to ~S~%" msg MB-NAM)
        (remote-mailbox-send! rmb msg) )
      ;Semblance of computation
      #;(repeat 10000)
      #;(thread-sleep! 1) )
    #; ;???
    (close-output-port (serializer-output))
    (begin
      (format #t "Sending |~S| to ~S~%" 'quit MB-NAM)
      (remote-mailbox-send! rmb 'quit)) ) )

(define (receiver)
  (let-values (((rmbs _) (server)))
    (handle-exceptions ex
      (begin (write-exn-condition ex) (newline))
      ;
      (print "* Receiving messages until quit...")
      (let receive-loop ()
        (let ((msg (mailbox-receive! (server-local-mailbox rmbs MB-NAM))))
          (format #t "Received |~S| from ~S~%" msg MB-NAM)
          (unless (eq? 'quit msg)
            (receive-loop) ) ) )
      (print "stopping mailbox server...")
      (remote-mailbox-server-stop! rmbs) ) ) )

;;;

(define operation
  (let ((args (command-line-arguments)))
    (and (pair? args)
         (string->symbol (last args))) ) )

(if operation
  ;then know what to do
  (case operation
    ((sender)
      (sender) )
    ((receiver)
      (receiver) )
    (else
      (error 'remote-mailbox-test "unrecognized operation: " operation) ) )
  ;else test w/ this binary
  (let ((cmd (first (argv))))
    ;the "server" MUST be started before the client!
    (print "Running Receiver: " cmd)
    ;csi args are ignored by this as a compiled binary - last arg is ours
    (process-run cmd `("-n" "-s" ,(program-name) "receiver"))
    (sleep 1) ;needed when this process is the sender
    (print "Running Sender: " cmd)
    ;short-circut
    #;(process-execute cmd `("-n" "-s" ,(program-name) "sender"))
    (sender) ) )
